#property indicator_chart_window
//---- input parameters
extern int nPeriod=9;
extern int Limit=350;
extern color WSO_Color=SandyBrown;
extern color WRO_Color=Aquamarine;
extern bool ShowPrice=false;
///---- int Widners Oscilator
int cnt,nCurBar=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   for(cnt=0; cnt<=5; cnt++)
      {
      ObjectDelete("WSO-"+cnt);
      ObjectDelete("WRO-"+cnt);
      }
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   for(cnt=0; cnt<=5; cnt++)
      {
      ObjectDelete("WSO-"+cnt);
      ObjectDelete("WRO-"+cnt);
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//---- TODO: add your code here
   double r1,r2,r3,r4,r5,r6;
   int rt1,rt2,rt3,rt4,rt5,rt6;
   double s1,s2,s3,s4,s5,s6;
   int st1,st2,st3,st4,st5,st6;
//----    
if(Bars<Limit) Limit=Bars-nPeriod;
for(nCurBar=Limit; nCurBar>0; nCurBar--)
   {
   if(Low[nCurBar+(nPeriod-1)/2] == Low[Lowest(NULL,0,MODE_LOW,nPeriod,nCurBar)])
      {
      s6=s5; s5=s4; s4=s3; s3=s2; s2=s1; s1=Low[nCurBar+(nPeriod-1)/2];
      st6=st5; st5=st4; st4=st3; st3=st2; st2=st1; st1=nCurBar+(nPeriod-1)/2;
      }
   if(High[nCurBar+(nPeriod-1)/2] == High[Highest(NULL,0,MODE_HIGH,nPeriod,nCurBar)])
      {
      r6=r5; r5=r4; r4=r3; r3=r2; r2=r1; r1=High[nCurBar+(nPeriod-1)/2];
      rt6=rt5; rt5=rt4; rt4=rt3; rt3=rt2; rt2=rt1; rt1=nCurBar+(nPeriod-1)/2;
      }
   }
//---- Move Object in Chart
FormatLine("WSO-0",Time[st1],s1,WSO_Color);
FormatLine("WSO-1",Time[st2],s2,WSO_Color);
FormatLine("WSO-2",Time[st3],s3,WSO_Color);
FormatLine("WSO-3",Time[st4],s4,WSO_Color);
FormatLine("WSO-4",Time[st5],s5,WSO_Color);
FormatLine("WSO-5",Time[st6],s6,WSO_Color);
//----
FormatLine("WRO-0",Time[rt1],r1,WRO_Color);
FormatLine("WRO-1",Time[rt2],r2,WRO_Color);
FormatLine("WRO-2",Time[rt3],r3,WRO_Color);
FormatLine("WRO-3",Time[rt4],r4,WRO_Color);
FormatLine("WRO-4",Time[rt5],r5,WRO_Color);
FormatLine("WRO-5",Time[rt6],r6,WRO_Color);

//----
   return(0);
  }

void FormatLine  (string objectName,datetime dt,double price, color clr)
{
   //ObjectCreate(objectName,OBJ_HLINE,0,0,0);
   ObjectDelete(objectName);
   ObjectCreate(objectName,OBJ_TREND,0,dt,price,dt+10080*60,price);
   ObjectSet(objectName,OBJPROP_RAY,True);
   ObjectSet(objectName,OBJPROP_WIDTH,1);
   ObjectSet(objectName,OBJPROP_STYLE, STYLE_DASHDOTDOT);
   ObjectSet(objectName,OBJPROP_COLOR,clr);
   ObjectMove(objectName,0,dt,price);
   if (ShowPrice)
      ObjectSetText(objectName,DoubleToStr(price,Digits));
}
//+------------------------------------------------------------------+

